---
title: Calculate Shipping Costs for DMC Local Delivery
slug: api-documentation/calculate-shipping-costs-for-dmc-local-delivery
docTags: 
createdAt: 2026-08-27T16:55:41.659Z
---

{
  "id": "eQBO66938t-hq2Juds1PW",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-calculate-with-local-priority",
    "servers": [
      {
        "url": "https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-calculate-with-local-priority"
      }
    ],
    "name": "Calculate Shipping Costs for DMC Local Delivery",
    "description": "<p>This endpoint is used for calculation of shipping costs for DMC delivery shipping method for using first location that support DMC Local delivery from the locations that user provides in request.</p>\n<p>Authorized permissions:</p>\n<ul>\n<li><code>dmc-shipping-calc.read</code></li>\n</ul>\n<p>Authorized roles:</p>\n<ul>\n<li>customer.default</li>\n<li>customer.anonymous</li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        },
        {
          "kind": "required",
          "name": "x-upstart-tenant",
          "type": "string",
          "description": "Tenant identifier associated with the site this call is for."
        },
        {
          "kind": "optional",
          "name": "x-upstart-site",
          "type": "string",
          "description": "Unique identifier for the site."
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "",
          "customType": "CalculatePriceWithLocalPriorityRequest",
          "schema": [
            {
              "name": "storesDistances",
              "kind": "required",
              "type": "array",
              "description": "",
              "modelRef": "#/components/schemas/StoreDistance",
              "customType": "StoreDistance[]",
              "schema": [
                {
                  "name": "storeId",
                  "kind": "required",
                  "type": "string",
                  "description": "",
                  "minLength": 1
                },
                {
                  "name": "distance",
                  "kind": "required",
                  "type": "number<double>",
                  "description": "",
                  "format": "double"
                }
              ]
            },
            {
              "name": "deliveryPostalCode",
              "kind": "required",
              "type": "string",
              "description": "",
              "minLength": 1
            },
            {
              "name": "stateCode",
              "kind": "optional",
              "type": "string",
              "description": ""
            },
            {
              "name": "weight",
              "kind": "required",
              "type": "number<double>",
              "description": "",
              "format": "double"
            },
            {
              "name": "itemsSubtotal",
              "kind": "optional",
              "type": "number<bigdecimal>",
              "description": "",
              "format": "bigdecimal"
            },
            {
              "name": "cartItems",
              "kind": "required",
              "type": "array",
              "description": "",
              "modelRef": "#/components/schemas/CartItem",
              "customType": "CartItem[]",
              "schema": [
                {
                  "name": "id",
                  "kind": "required",
                  "type": "string",
                  "description": ""
                },
                {
                  "name": "catalogItemId",
                  "kind": "required",
                  "type": "string",
                  "description": ""
                },
                {
                  "name": "productItemSkuId",
                  "kind": "required",
                  "type": "string",
                  "description": ""
                },
                {
                  "name": "quantity",
                  "kind": "required",
                  "type": "number",
                  "description": ""
                },
                {
                  "name": "shipmentId",
                  "kind": "required",
                  "type": "string",
                  "description": ""
                },
                {
                  "name": "pricing",
                  "kind": "required",
                  "type": "object",
                  "description": "",
                  "modelRef": "#/components/schemas/CartItemPricing",
                  "customType": "CartItemPricing",
                  "schema": [
                    {
                      "name": "basePrice",
                      "kind": "optional",
                      "type": "object",
                      "description": "",
                      "modelRef": "#/components/schemas/BasePrice",
                      "customType": "BasePrice",
                      "schema": [
                        {
                          "name": "type",
                          "kind": "required",
                          "type": "string",
                          "description": ""
                        },
                        {
                          "name": "zone",
                          "kind": "required",
                          "type": "string",
                          "description": ""
                        },
                        {
                          "name": "price",
                          "kind": "required",
                          "type": "number",
                          "description": ""
                        }
                      ]
                    },
                    {
                      "name": "promotionPriceAdjustments",
                      "kind": "optional",
                      "type": "array",
                      "description": "",
                      "modelRef": "#/components/schemas/PromotionPriceAdjustment",
                      "customType": "PromotionPriceAdjustment[]",
                      "schema": [
                        {
                          "name": "id",
                          "kind": "required",
                          "type": "string",
                          "description": ""
                        },
                        {
                          "name": "value",
                          "kind": "required",
                          "type": "number",
                          "description": ""
                        }
                      ]
                    },
                    {
                      "name": "feePriceAdjustments",
                      "kind": "optional",
                      "type": "array",
                      "description": "",
                      "modelRef": "#/components/schemas/FeePriceAdjustment",
                      "customType": "FeePriceAdjustment[]",
                      "schema": [
                        {
                          "name": "id",
                          "kind": "required",
                          "type": "string",
                          "description": ""
                        },
                        {
                          "name": "value",
                          "kind": "required",
                          "type": "number",
                          "description": ""
                        }
                      ]
                    },
                    {
                      "name": "taxPriceAdjustment",
                      "kind": "optional",
                      "type": "object",
                      "description": "",
                      "modelRef": "#/components/schemas/TaxPriceAdjustment",
                      "customType": "TaxPriceAdjustment",
                      "schema": [
                        {
                          "name": "taxCode",
                          "kind": "required",
                          "type": "string",
                          "description": ""
                        },
                        {
                          "name": "value",
                          "kind": "optional",
                          "type": "number",
                          "description": ""
                        }
                      ]
                    }
                  ]
                }
              ]
            }
          ],
          "modelRef": "#/components/schemas/CalculatePriceWithLocalPriorityRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "NoChannelPortalAccess",
          "name": "NoChannelPortalAccess",
          "kind": "optional",
          "type": "http",
          "description": "<p>This authentication is required for clients to interact with any of the management APIs. Similar to 'LoggedIn', it indicates that the user has actually logged into the system, but in this case with a management role.</p>",
          "scheme": "bearer"
        },
        {
          "id": "LoggedIn",
          "name": "LoggedIn",
          "kind": "optional",
          "type": "http",
          "description": "The presence of this token indicates that the user is a known consumer that has previously logged into the platform.",
          "scheme": "bearer"
        },
        {
          "id": "AnonymousAuth",
          "name": "AnonymousAuth",
          "kind": "optional",
          "type": "http",
          "description": "This is the most basic authentication. The minimum requirement for access is a token representing the user as an anonymous client.",
          "scheme": "bearer"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "201",
        "description": "<p>Success–shipping method created.</p>",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "DMCShippingPriceFromStore",
            "schema": [
              {
                "name": "storeId",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "dropOffAmount",
                "kind": "optional",
                "type": "number",
                "description": ""
              },
              {
                "name": "whiteGloveAmount",
                "kind": "optional",
                "type": "number",
                "description": ""
              },
              {
                "name": "whiteGlovePlusAmount",
                "kind": "optional",
                "type": "number",
                "description": ""
              },
              {
                "name": "maxHaulAwayLimit",
                "kind": "optional",
                "type": "number",
                "description": ""
              },
              {
                "name": "isFreight",
                "kind": "required",
                "type": "boolean",
                "description": ""
              },
              {
                "name": "haulAwayEnabled",
                "kind": "required",
                "type": "boolean",
                "description": ""
              },
              {
                "name": "rateType",
                "kind": "optional",
                "type": "string<BaseDistanceRate | StoreGlobalRate | StateRate | PostalCodeLocalRate | PostalCodeFreightRate>",
                "description": "",
                "enum": [
                  "BaseDistanceRate",
                  "StoreGlobalRate",
                  "StateRate",
                  "PostalCodeLocalRate",
                  "PostalCodeFreightRate"
                ]
              }
            ],
            "modelRef": "#/components/schemas/DMCShippingPriceFromStore",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "The request contained information that the server was unable to process. Appropriate errors are provided in the response body.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ValidationErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ValidationErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "sHfTMtyHK3nX3uGbzI7OW",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-calculate-with-local-priority \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --header 'x-upstart-tenant: string' \\\n     --data '{\n     \"storesDistances\": [\n     {\n     \"storeId\": \"\",\n     \"distance\": \"\"\n     }\n     ],\n     \"deliveryPostalCode\": \"\",\n     \"weight\": \"\",\n     \"cartItems\": [\n     {\n     \"id\": \"\",\n     \"catalogItemId\": \"\",\n     \"productItemSkuId\": \"\",\n     \"quantity\": \"\",\n     \"shipmentId\": \"\",\n     \"pricing\": {\n     \"basePrice\": {\n     \"type\": \"\",\n     \"zone\": \"\",\n     \"price\": \"\"\n     },\n     \"promotionPriceAdjustments\": [\n     {\n     \"id\": \"\",\n     \"value\": \"\"\n     }\n     ],\n     \"feePriceAdjustments\": [\n     {\n     \"id\": \"\",\n     \"value\": \"\"\n     }\n     ],\n     \"taxPriceAdjustment\": {\n     \"taxCode\": \"\"\n     }\n     }\n     }\n     ]\n     }'"
        },
        {
          "id": "UpRGWVi6dtfgCMKUg42IA",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\nmyHeaders.append(\"x-upstart-tenant\", \"string\");\n\nvar raw = JSON.stringify({\n   \"storesDistances\": [\n      {\n         \"storeId\": \"\",\n         \"distance\": \"\"\n      }\n   ],\n   \"deliveryPostalCode\": \"\",\n   \"weight\": \"\",\n   \"cartItems\": [\n      {\n         \"id\": \"\",\n         \"catalogItemId\": \"\",\n         \"productItemSkuId\": \"\",\n         \"quantity\": \"\",\n         \"shipmentId\": \"\",\n         \"pricing\": {\n            \"basePrice\": {\n               \"type\": \"\",\n               \"zone\": \"\",\n               \"price\": \"\"\n            },\n            \"promotionPriceAdjustments\": [\n               {\n                  \"id\": \"\",\n                  \"value\": \"\"\n               }\n            ],\n            \"feePriceAdjustments\": [\n               {\n                  \"id\": \"\",\n                  \"value\": \"\"\n               }\n            ],\n            \"taxPriceAdjustment\": {\n               \"taxCode\": \"\"\n            }\n         }\n      }\n   ]\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-calculate-with-local-priority\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "uC3KMzAXXIhvBYUoEM4kZ",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-calculate-with-local-priority\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest[\"x-upstart-tenant\"] = \"string\"\nrequest.body = JSON.dump({\n   \"storesDistances\": [\n      {\n         \"storeId\": \"\",\n         \"distance\": \"\"\n      }\n   ],\n   \"deliveryPostalCode\": \"\",\n   \"weight\": \"\",\n   \"cartItems\": [\n      {\n         \"id\": \"\",\n         \"catalogItemId\": \"\",\n         \"productItemSkuId\": \"\",\n         \"quantity\": \"\",\n         \"shipmentId\": \"\",\n         \"pricing\": {\n            \"basePrice\": {\n               \"type\": \"\",\n               \"zone\": \"\",\n               \"price\": \"\"\n            },\n            \"promotionPriceAdjustments\": [\n               {\n                  \"id\": \"\",\n                  \"value\": \"\"\n               }\n            ],\n            \"feePriceAdjustments\": [\n               {\n                  \"id\": \"\",\n                  \"value\": \"\"\n               }\n            ],\n            \"taxPriceAdjustment\": {\n               \"taxCode\": \"\"\n            }\n         }\n      }\n   ]\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "Skq-6dNPChMOAt-kJIjOg",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-calculate-with-local-priority\"\n\npayload = json.dumps({\n   \"storesDistances\": [\n      {\n         \"storeId\": \"\",\n         \"distance\": \"\"\n      }\n   ],\n   \"deliveryPostalCode\": \"\",\n   \"weight\": \"\",\n   \"cartItems\": [\n      {\n         \"id\": \"\",\n         \"catalogItemId\": \"\",\n         \"productItemSkuId\": \"\",\n         \"quantity\": \"\",\n         \"shipmentId\": \"\",\n         \"pricing\": {\n            \"basePrice\": {\n               \"type\": \"\",\n               \"zone\": \"\",\n               \"price\": \"\"\n            },\n            \"promotionPriceAdjustments\": [\n               {\n                  \"id\": \"\",\n                  \"value\": \"\"\n               }\n            ],\n            \"feePriceAdjustments\": [\n               {\n                  \"id\": \"\",\n                  \"value\": \"\"\n               }\n            ],\n            \"taxPriceAdjustment\": {\n               \"taxCode\": \"\"\n            }\n         }\n      }\n   ]\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json',\n   'x-upstart-tenant': 'string'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "sHfTMtyHK3nX3uGbzI7OW"
    },
    "results": {
      "languages": [
        {
          "id": "XoXKPnPpeSfIqiyPZ2aEo",
          "language": "201",
          "code": "// Success–shipping method created.\n{\n  \"storeId\": \"\",\n  \"dropOffAmount\": 0,\n  \"whiteGloveAmount\": 0,\n  \"whiteGlovePlusAmount\": 0,\n  \"maxHaulAwayLimit\": 0,\n  \"isFreight\": false,\n  \"haulAwayEnabled\": false,\n  \"rateType\": \"\"\n}"
        },
        {
          "id": "dzZNmf2u4xUqrf01j7p3I",
          "language": "400",
          "code": "// The request contained information that the server was unable to process. Appropriate errors are provided in the response body.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\"\n}"
        },
        {
          "id": "t9LUeNgvL7VbRNcM_Y9pK",
          "language": "401",
          "code": "// The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "XoXKPnPpeSfIqiyPZ2aEo"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}